//+------------------------------------------------------------------+
//|                                                   _i_FXGauge.mq4 |
//|                                     Copyright  2006, Doji Starr |
//|                                                                  |
//|                                    adapted by jasondavis87(2011) |
//|                                         adapted by slimtom(2011) |
//|                                       * adapted by brax64 (2012) |
//|                                                                  |
//| * cleanup code, add MA matrix panel and removed "Traffic Light", |
//|   cosmetic update, new deinit structure.                         |
//+------------------------------------------------------------------+

#property copyright "Copyright  2006, Doji Starr"

#property indicator_chart_window

string        info____     = "---- Chart Shift, Spacing, Width ----";
extern int    Shift        = 3;
extern int    Spacing      = 5;
extern int    Width        = 4;
extern int    MA_mode      = 0;
extern string info_        = "---- Target Settings - SET to Zero to disable ---";
extern int    target_pips1 = 0;
extern int    target_pips2 = 0;
extern int    target_pips3 = 0;
extern bool   Draw_matrix  = true;

#define NSL    8       // number of shade levels
#define NSVR   17      // number of solid vertical lines
#define NMA    7       // number of MAs, change ma_period[NMA-1] accordingly 
#define NTF    4       // number of time frames/lanes, change tfp[NTF] accordinlgy

double   fml[NTF][NMA];                                    // momentum lines
double   bsl_up[NTF][NSL];                                 // color shades levels to the up side
double   bsl_down[NTF][NSL];                               // color shades levels to the down side
double   bsl[NSL];                                         // color shades distances ('point' adjusted)
double   srl[24];                                          // support/resistance levels (total = 2*NSL + NMA + 1(Bid) )
double   price, average1, average2, point;
double   tmpArray[NMA], lowestMA, highestMA;
int      srgap, tfc, mac;                                  // color shades distances
int      _bsl[NSL]    = {8, 13, 21, 34, 55, 89, 144, 233}; // time shades distance pure fibo sequence; original was: 9, 16, 26, 42, 68, 110, 178, 244
int      ma_period[6] = {21,34,55,75,100,144,233};         // SMAs, NMA-1
int      tfp[NTF]     = {1,5,15,60};                       // Time frames/lanes - in minutes. Like H4=240, D1=1440 etc...
int      counted_bars, startBar, bar, i, y;
int      gap = 10;
int      tf, c, offset, xUnit;
int      shift, spacing, width, supports, resistances;
color    Shade[NSL]    = {C'220,240,255', C'180,210,255', C'140,180,255', C'100,150,255', C'60,120,255', C'20,90,255', C'0,60,255'};
color    col, macolor;
string   objName, dir, MA, name;
string   uniqueid = "FXGv3: ";
datetime curTime;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{
   xUnit   = Period() * 60;
   shift   = Shift * xUnit;
   spacing = Spacing * xUnit;
   width   = Width * xUnit;
   point   = 0.01;
   if(Digits > 3) point = 0.0001;

//+------------------------------------------------------------------+
//| creating the objects for drawing the grid                        |
//+------------------------------------------------------------------+

   for(i=0; i<NSL; i++)  bsl[i] = _bsl[i]*point;
   for(tf=0; tf<NTF; tf++)
   {
      for(i=0; i<NSL; i++)
      {
         objName = uniqueid + "bsl_up_rect_" + tf + "_" + i;          // upper zones
         ObjectCreate(objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, Shade[i]);
            
         objName = uniqueid + "ext_bsl_up_rect_" + tf;            // external upper zones
         ObjectCreate(objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, C'255,255,150');
            
         objName = uniqueid + "bsl_down_rect_" + tf + "_" + i;        // lower zones
         ObjectCreate(objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, Shade[i]);
            
         objName = uniqueid + "ext_bsl_down_rect_" + tf;          // external lower zones
         ObjectCreate(objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, C'255,255,150');
/*            
         objName = uniqueid+"bsl_up_bar_"+tf+"_"+i;           // upper zone separator lines
         ObjectCreate(objName, OBJ_TREND, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, Gray);
            ObjectSet(objName, OBJPROP_RAY, false);
            ObjectSet(objName, OBJPROP_WIDTH, 1);
            ObjectSet(objName, OBJPROP_STYLE, 2);
            
         objName = uniqueid+"bsl_down_bar_"+tf+"_"+i;         // lower zone separator lines
         ObjectCreate(objName, OBJ_TREND, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, Gray);
            ObjectSet(objName, OBJPROP_RAY, false);
            ObjectSet(objName, OBJPROP_WIDTH, 1);
            ObjectSet(objName, OBJPROP_STYLE, 2);
*/
      }

      objName = uniqueid + "MidShade_" + tf;                      // price zone
      ObjectCreate(objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
         ObjectSet(objName, OBJPROP_COLOR, C'255,255,100');

      for(i=0; i<NMA; i++)
      {
         objName = uniqueid + "fml_bar_" + tf + "_" + i;              // horizontal momentum lines
         ObjectCreate(objName, OBJ_TREND, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, Blue);
            ObjectSet(objName, OBJPROP_RAY, false);
            ObjectSet(objName, OBJPROP_WIDTH, 1);
         if(i<2 || i == NMA-1)
            ObjectSet(objName, OBJPROP_WIDTH, 3);
      }

      for(i=1; i<=NSVR; i++)
      {
         objName = uniqueid + "svr_" + tf + "_" + i;                  // solid vertical lines (10 pips or more)
         ObjectCreate(objName, OBJ_TREND, 0, 0, 0, 0, 0);
         ObjectSet(objName, OBJPROP_RAY, false);
         ObjectSet(objName, OBJPROP_WIDTH, 3);
            
         objName = uniqueid + "ext_up_svr_" + tf;                 // extern upper vertical lines
         ObjectCreate(objName, OBJ_TREND, 0, 0, 0, 0, 0);
         ObjectSet(objName, OBJPROP_RAY, false);
         ObjectSet(objName, OBJPROP_WIDTH, 3);
            
         objName = uniqueid + "ext_down_svr_" + tf;               // extern lower vertical lines
         ObjectCreate(objName, OBJ_TREND, 0, 0, 0, 0, 0);
         ObjectSet(objName, OBJPROP_RAY, false);
         ObjectSet(objName, OBJPROP_WIDTH, 3);
      }
   }
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+

int deinit()
{
   string lookFor       = uniqueid;
   int    lookForLength = StringLen(lookFor);   
   for(int i = ObjectsTotal() - 1; i >= 0; i--)
   {
      string name = ObjectName(i);
         if(StringSubstr(name, 0, lookForLength) == lookFor) ObjectDelete(name);
   }
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
{
   int X = -10, Y = 15, A = 10, B = 12;
   point   = 0.01;
   if(Digits > 3) point = 0.0001;

//+------------------------------------------------------------------+
//| Time lines                                                       |
//+------------------------------------------------------------------+

   int short_gap_count;
   int long_gap_count;
   int sr_short_gap_count;
   int sr_long_gap_count;
   curTime = Time[0];
   price   = Close[0];
    
   for(tf=0; tf<NTF; tf++)
   {
      bar = iBarShift(NULL, tfp[tf], curTime, false);
      for(i=0; i<NMA; i++)  fml[tf][i] = iMA(NULL, tfp[tf], ma_period[i], 0, MA_mode, PRICE_CLOSE, bar/Period());  // populating the fml array...
      for(i=0; i<NMA; i++) tmpArray[i] = fml[tf][i];                                                               // finding the highest and lowest MAs from the (7) fml's/MA's
      ArraySort(tmpArray);                                                                                         // copying the MAs levels of this TF to one dim array to feed ArrayBsearch
         lowestMA  = tmpArray[0];
         highestMA = tmpArray[6];

      for(i=0; i<NSL; i++)                                                                                         // populating the bsl arrays...
      {
         bsl_up[tf][i]   = lowestMA  + bsl[i];
         bsl_down[tf][i] = highestMA - bsl[i];
      }
   }

//+------------------------------------------------------------------+
//| drawing the color shades of the grid from top to bottom          |
//+------------------------------------------------------------------+

   for(tf=0; tf<NTF; tf++) 
   {
      offset = 0;                                                                // find the number of overlapping shades
      for(i=offset; i<NSL-1; i++) if(bsl_up[tf][i] <= bsl_down[tf][i]) offset++;

      if(offset > 0)                                                             // hide first level objects' overlapping, so they wont be left as 'ghosts'
      {
         objName = uniqueid + "bsl_up_rect_" + tf + "_" + (NSL-2-offset+1);
            ObjectSet(objName, OBJPROP_TIME1,  0);
            ObjectSet(objName, OBJPROP_TIME2,  0);
            ObjectSet(objName, OBJPROP_PRICE1, 0);
            ObjectSet(objName, OBJPROP_PRICE2, 0);
            
         objName = uniqueid + "bsl_down_rect_" + tf + "_" + (NSL-2-offset+1);
            ObjectSet(objName, OBJPROP_TIME1,  0);
            ObjectSet(objName, OBJPROP_TIME2,  0);
            ObjectSet(objName, OBJPROP_PRICE1, 0);
            ObjectSet(objName, OBJPROP_PRICE2, 0);
/*
         objName = uniqueid+"bsl_up_bar_"+tf+"_"+(NSL-2-offset+1);
            ObjectSet(objName, OBJPROP_TIME1,  0);
            ObjectSet(objName, OBJPROP_TIME2,  0);
            ObjectSet(objName, OBJPROP_PRICE1, 0);
            ObjectSet(objName, OBJPROP_PRICE2, 0);

         objName = uniqueid+"bsl_down_bar_"+tf+"_"+(NSL-2-offset+1);
            ObjectSet(objName, OBJPROP_TIME1,  0);
            ObjectSet(objName, OBJPROP_TIME2,  0);
            ObjectSet(objName, OBJPROP_PRICE1, 0);
            ObjectSet(objName, OBJPROP_PRICE2, 0);
*/
      }
        
      double highest=0;
      for(i=NSL-2; i>=offset; i--)
      {
         objName = uniqueid + "bsl_up_rect_" + tf + "_" + (i-offset);
            ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing);
            ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+tf*spacing+width);
            ObjectSet(objName, OBJPROP_PRICE1, bsl_up[tf][i]);
            ObjectSet(objName, OBJPROP_PRICE2, bsl_up[tf][i+1]);
                
         if (bsl_down[tf][i]>highest) highest=bsl_up[tf][i+1];
/*            
         objName = uniqueid+"bsl_up_bar_"+tf+"_"+(i-offset);
            ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing);
            ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+tf*spacing+width);
            ObjectSet(objName, OBJPROP_PRICE1, bsl_up[tf][i]);
            ObjectSet(objName, OBJPROP_PRICE2, bsl_up[tf][i]);
*/            
      }

      double lowest=9999.9999;
      for(i=0; i<NSL-1; i++)
      {
         objName = uniqueid + "bsl_down_rect_" + tf + "_" + (i-offset);
            ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing);
            ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+tf*spacing+width);
            ObjectSet(objName, OBJPROP_PRICE1, bsl_down[tf][i]);
            ObjectSet(objName, OBJPROP_PRICE2, bsl_down[tf][i+1]);
         
         if(bsl_down[tf][i]<lowest) lowest=bsl_down[tf][i+1];
/*            
         objName = uniqueid+"bsl_down_bar_"+tf+"_"+(i-offset);
            ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing);
            ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+tf*spacing+width);
            ObjectSet(objName, OBJPROP_PRICE1, bsl_down[tf][i]);
            ObjectSet(objName, OBJPROP_PRICE2, bsl_down[tf][i]);
*/
      }

      objName = uniqueid + "MidShade_" + tf;
         ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing);
         ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+tf*spacing+width);
         ObjectSet(objName, OBJPROP_PRICE1, bsl_up[tf][offset]);
         ObjectSet(objName, OBJPROP_PRICE2, bsl_down[tf][offset]);
      
      objName = uniqueid + "ext_bsl_up_rect_" + tf;
         ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing);
         ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+tf*spacing+width);
         ObjectSet(objName, OBJPROP_PRICE1, highest);
         ObjectSet(objName, OBJPROP_PRICE2, WindowPriceMax());
            
      objName = uniqueid + "ext_up_svr_" + tf;
         ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing+Width/2*xUnit);
         ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+tf*spacing+Width/2*xUnit);
         ObjectSet(objName, OBJPROP_PRICE1, highest);
         ObjectSet(objName, OBJPROP_PRICE2, WindowPriceMax());   
         ObjectSet(objName, OBJPROP_COLOR,  Green);
      
      objName = uniqueid + "ext_bsl_down_rect_" + tf;
         ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing);
         ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+tf*spacing+width);
         ObjectSet(objName, OBJPROP_PRICE1, lowest);
         ObjectSet(objName, OBJPROP_PRICE2, WindowPriceMin());
        
      objName = uniqueid + "ext_down_svr_" + tf;
         ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing+Width/2*xUnit);
         ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+tf*spacing+Width/2*xUnit);
         ObjectSet(objName, OBJPROP_PRICE1, lowest);
         ObjectSet(objName, OBJPROP_PRICE2, WindowPriceMin());
         ObjectSet(objName, OBJPROP_COLOR,  FireBrick);

//+------------------------------------------------------------------+
//| drawing the momentum lines bars                                  |
//+------------------------------------------------------------------+

      for(i=0; i<NMA; i++)
      {
         objName = uniqueid + "fml_bar_" + tf + "_" + i;
            ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing+xUnit);
            ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+tf*spacing+width-xUnit);
            ObjectSet(objName, OBJPROP_PRICE1, fml[tf][i]);
            ObjectSet(objName, OBJPROP_PRICE2, fml[tf][i]);

         if(i==0)
         {
            if(fml[tf][i] >= price) col = Red;
            else                    col = Lime;
            ObjectSet(objName, OBJPROP_COLOR, col);
         }
         if(i==1)
         {
            if(fml[tf][i] >= price) col = FireBrick;
            else                    col = ForestGreen;
            ObjectSet(objName, OBJPROP_COLOR, col);
         }
      }

//+------------------------------------------------------------------+
//| drawing the MA matrix (brax64)                                   |
//+------------------------------------------------------------------+
   if(Draw_matrix)
   {
      draw_bkgrd();
      
      X += 70;
      for(i=0; i<NMA; i++)
      {
         Y += 15;
         macolor = DarkGray;
         name = uniqueid + "fml_price_" + tf + "_" + i;
         string mavalue = DoubleToStr(fml[tf][i],5);
         if(fml[tf][i]  > Bid+1.5*point) macolor = Crimson;
         if(fml[tf][i]  < Bid-1.5*point) macolor = DodgerBlue;
         ma_matrix(name, mavalue, X, Y, tf, i, macolor);         

         string MA = "MA " + ma_period[i];
         string obj_name1;
         obj_name1 = uniqueid + "MA period_" + i;            
         ma_column(obj_name1, MA, A, Y, i);   
      }
      Y = 15;

      string TF = "TF " + tfp[tf];
      string obj_tf;
      obj_tf = uniqueid + "TF period_" + tf;
      tf_row(obj_tf, TF, X, B, tf);
   }
     
//+------------------------------------------------------------------+
//| drawing the solid vertical lines                                 |
//+------------------------------------------------------------------+      

      ArrayInitialize(srl, -1);
      for (i=0; i<NMA; i++) srl[i] = fml[tf][i];
      for (i=offset; i<NSL; i++)
      {
         srl[NMA+i] = bsl_down[tf][i];
         srl[NMA+NSL+i] = bsl_up[tf][i];
      }
      
      srl[NMA+2*NSL] = price;
      ArraySort(srl);

      c           = 0;          // looking for a gap of 10 pips or more
      supports    = 0;
      resistances = 0;
      for(i=0; i<NMA+2*NSL+2; i++)
      {
         if(srl[i] > price) resistances++;
         if(srl[i] < price) supports++;
         if(-1 == srl[i])
            continue;
         if(srl[i+1]-srl[i] >= gap*point)
         {
            c++;
            objName = uniqueid + "svr_" + tf + "_" + c;
               ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing+Width/2*xUnit);
               ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+Width/2*xUnit);
               ObjectSet(objName, OBJPROP_PRICE1, srl[i]+point);
               ObjectSet(objName, OBJPROP_PRICE2, srl[i+1]-point);

            if (srl[i+1] <= price)
            {
               if(price==srl[i+1]) short_gap_count++;
               ObjectSet(objName, OBJPROP_COLOR, FireBrick);
            }
            else
            {
               if(price==srl[i]) long_gap_count++;
               ObjectSet(objName, OBJPROP_COLOR, Green);
            }
         }
         
         if (srl[i+1]-srl[i] >= srgap*point)
         {
            if(srl[i+1] <= price)
               if(price==srl[i+1]) sr_short_gap_count++;
               else
               if(price==srl[i])   sr_long_gap_count++;
         }

      }
      
      if(supports == 0) 
      {
         sr_short_gap_count++;
         short_gap_count++;
      }
      
      if(resistances == 0) 
      {
         sr_long_gap_count++;
         long_gap_count++;
      }

      if(c >= NSVR) Print("Warning: NSVR exceeded");
      else  // hide the unused vertical lines objects so they wont be left as 'ghosts' (only the first)
      {
         objName = uniqueid + "svr_" + tf + "_" + (c+1);
            ObjectSet(objName, OBJPROP_TIME1, 0);
            ObjectSet(objName, OBJPROP_TIME2, 0);
            ObjectSet(objName, OBJPROP_PRICE1, 0);
            ObjectSet(objName, OBJPROP_PRICE2, 0);
      }
   }

//+------------------------------------------------------------------+
//| drawing the TP lines                                             |
//+------------------------------------------------------------------+ 

   string t1u = uniqueid + "TP1 up";
   string t2u = uniqueid + "TP2 up";
   string t3u = uniqueid + "TP3 up";
   string t1d = uniqueid + "TP1 dn";
   string t2d = uniqueid + "TP2 dn";
   string t3d = uniqueid + "TP3 dn";

   if(target_pips1 > 0)
   {
      ObjectCreate(t1u,OBJ_TREND,0,Time[50], Ask+(target_pips1*point),Time[1],Ask+(target_pips1*point));
         ObjectSet(t1u,OBJPROP_STYLE,STYLE_SOLID);
         ObjectSet(t1u,OBJPROP_WIDTH,1);
         ObjectSet(t1u,OBJPROP_RAY,false);
         ObjectSet(t1u,OBJPROP_COLOR,RoyalBlue);
   
      ObjectCreate(t1d,OBJ_TREND,0,Time[50], Bid-(target_pips1*point),Time[1],Bid-(target_pips1*point));
         ObjectSet(t1d,OBJPROP_STYLE,STYLE_SOLID);
         ObjectSet(t1d,OBJPROP_WIDTH,1);
         ObjectSet(t1d,OBJPROP_RAY,false);
         ObjectSet(t1d,OBJPROP_COLOR,Maroon);
   }

   if(target_pips2 > 0)
   {
      ObjectCreate(t2u,OBJ_TREND,0,Time[50], Ask+(target_pips2*point),Time[1],Ask+(target_pips2*point));
         ObjectSet(t2u,OBJPROP_STYLE,STYLE_SOLID);
         ObjectSet(t2u,OBJPROP_WIDTH,1);
         ObjectSet(t2u,OBJPROP_RAY,false);
         ObjectSet(t2u,OBJPROP_COLOR,DodgerBlue);
   
      ObjectCreate(t2d,OBJ_TREND,0,Time[50], Bid-(target_pips2*point),Time[1],Bid-(target_pips2*point));
         ObjectSet(t2d,OBJPROP_STYLE,STYLE_SOLID);
         ObjectSet(t2d,OBJPROP_WIDTH,1);
         ObjectSet(t2d,OBJPROP_RAY,false);
         ObjectSet(t2d,OBJPROP_COLOR,Crimson);
   }
   
   if(target_pips3 > 0)
   {
      ObjectCreate(t3u,OBJ_TREND,0,Time[50], Ask+(target_pips3*point),Time[1],Ask+(target_pips3*point));
         ObjectSet(t3u,OBJPROP_STYLE,STYLE_SOLID);
         ObjectSet(t3u,OBJPROP_WIDTH,1);
         ObjectSet(t3u,OBJPROP_RAY,false);
         ObjectSet(t3u,OBJPROP_COLOR,DeepSkyBlue);
   
      ObjectCreate(t3d,OBJ_TREND,0,Time[50], Bid-(target_pips3*point),Time[1],Bid-(target_pips3*point));
         ObjectSet(t3d,OBJPROP_STYLE,STYLE_SOLID);
         ObjectSet(t3d,OBJPROP_WIDTH,1);
         ObjectSet(t3d,OBJPROP_RAY,false);
         ObjectSet(t3d,OBJPROP_COLOR,Red);
   }

}

//+------------------------------------------------------------------+
//| Subroutines                                                      |
//+------------------------------------------------------------------+

void draw_bkgrd()
{
   string bkgrd0, bkgrd1, smb, mamode;
   bkgrd0 = uniqueid + "bkgrd_0";
   bkgrd1 = uniqueid + "bkgrd_1";
   smb    = uniqueid + "bkgrd_2";
   mamode = uniqueid + "bkgrd_3";
   
   ObjectCreate(bkgrd0, OBJ_LABEL, 0, 0, 0);
      ObjectSet(bkgrd0, OBJPROP_CORNER, 0);
      ObjectSet(bkgrd0, OBJPROP_XDISTANCE, 0);
      ObjectSet(bkgrd0, OBJPROP_YDISTANCE, 0);      
      ObjectSet(bkgrd0, OBJPROP_COLOR, Black);
      ObjectSet(bkgrd0, OBJPROP_BACK, false);
      ObjectSetText(bkgrd0, "gggg", 65, "Webdings");
      if(NTF == 5) ObjectSetText(bkgrd0, "ggggg", 62, "Webdings");

   ObjectCreate(bkgrd1, OBJ_LABEL, 0, 0, 0);
      ObjectSet(bkgrd1, OBJPROP_CORNER, 0);
      ObjectSet(bkgrd1, OBJPROP_XDISTANCE, 0);
      ObjectSet(bkgrd1, OBJPROP_YDISTANCE, 65);      
      ObjectSet(bkgrd1, OBJPROP_COLOR, Black);
      ObjectSet(bkgrd1, OBJPROP_BACK, false);
      ObjectSetText(bkgrd1, "gggg", 65, "Webdings");
      if(NTF == 5) ObjectSetText(bkgrd1, "ggggg", 62, "Webdings");
   
   ObjectCreate(smb, OBJ_LABEL, 0, 0, 0);
      ObjectSet(smb, OBJPROP_CORNER, 0);
      ObjectSet(smb, OBJPROP_XDISTANCE, 5);
      ObjectSet(smb, OBJPROP_YDISTANCE, 0);
      ObjectSet(smb, OBJPROP_BACK, false);
      ObjectSetText(smb, StringSubstr(Symbol(),0,6), 10, "Verdana Bold Italic", DarkOrange);
   
   string MAmode;
   switch(MA_mode)
   {
      case 0: MAmode = "SMA";  break;
      case 1: MAmode = "EMA";  break;
      case 2: MAmode = "SMMA"; break;
      case 3: MAmode = "LWMA"; break;
   }
   
   ObjectDelete(mamode);
   ObjectCreate(mamode, OBJ_LABEL, 0, 0, 0);
      ObjectSet(mamode, OBJPROP_CORNER, 0);
      ObjectSet(mamode, OBJPROP_XDISTANCE, 10);
      ObjectSet(mamode, OBJPROP_YDISTANCE, 135);
      ObjectSet(mamode, OBJPROP_BACK, false);
      ObjectSetText(mamode, MAmode, 7, "Verdana Bold", DarkOrange);
      
}

void ma_matrix(string name, string mavalue, int X, int Y, int tf, int i, color macolor)
{
   ObjectDelete(name);
   ObjectCreate(name, OBJ_LABEL, 0, 0, 0);
      ObjectSet(name, OBJPROP_CORNER, 0);
      ObjectSet(name, OBJPROP_XDISTANCE, X + 5);
      ObjectSet(name, OBJPROP_YDISTANCE, Y);
      ObjectSet(name, OBJPROP_BACK, false);
      ObjectSetText(name, mavalue, 8, "Verdana", macolor);
}

void ma_column(string obj_name1, string MA, int A, int Y, int i)
{
   ObjectDelete(obj_name1);
   ObjectCreate(obj_name1, OBJ_LABEL, 0, 0, 0);
      ObjectSet(obj_name1, OBJPROP_CORNER, 0);
      ObjectSet(obj_name1, OBJPROP_XDISTANCE, A);
      ObjectSet(obj_name1, OBJPROP_YDISTANCE, Y);
      ObjectSet(obj_name1, OBJPROP_BACK, false);
      ObjectSet(obj_name1, OBJPROP_COLOR, WhiteSmoke);
      ObjectSetText(obj_name1, MA, 8, "Verdana Bold");
}

void tf_row(string obj_tf, string TF, int X, int B, int tf)
{
   int    f_size = 10;
   string f_type = "Verdana Bold";
   ObjectDelete(obj_tf);
   ObjectCreate(obj_tf, OBJ_LABEL, 0, 0, 0);
      ObjectSet(obj_tf, OBJPROP_CORNER, 0);
      ObjectSet(obj_tf, OBJPROP_XDISTANCE, X + 13);
      ObjectSet(obj_tf, OBJPROP_YDISTANCE, B);
      ObjectSet(obj_tf, OBJPROP_COLOR, WhiteSmoke);
      if(tfp[tf] == Period())
      {
         f_size = 13;
         f_type = "Arial Black";
         ObjectSet(obj_tf, OBJPROP_COLOR, DarkOrange);
         ObjectSet(obj_tf, OBJPROP_XDISTANCE, X + 4);
         ObjectSet(obj_tf, OBJPROP_YDISTANCE, B - 5);
      }
      ObjectSet(obj_tf, OBJPROP_BACK, false);
      ObjectSetText(obj_tf, TF, f_size, f_type);
      
}

